package com.lovecoding.rabbitmq.producer;

import com.rabbitmq.client.BuiltinExchangeType;
import com.rabbitmq.client.Channel;
import com.rabbitmq.client.Connection;
import com.rabbitmq.client.ConnectionFactory;
import com.rabbitmq.client.impl.AMQImpl;
import org.junit.jupiter.api.Test;
import org.springframework.amqp.rabbit.core.RabbitTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.util.concurrent.TimeoutException;

@SpringBootTest
class ProducerApplicationTests {

    @Resource
    RabbitTemplate rabbitTemplate;

    @Test
    void t1() throws InterruptedException {

        for (int i = 0; i < 100; i++) {
            rabbitTemplate.convertAndSend(
                    "testQueue", "测试消息ID ：" + i );
            Thread.sleep(100);
        }

    }





    @Test
    void sendMsg() throws IOException, TimeoutException {
        //创建一个连接
        ConnectionFactory connectionFactory = new ConnectionFactory();
        connectionFactory.setHost("localhost");
        connectionFactory.setPort(25672);
        connectionFactory.setUsername("admin");
        connectionFactory.setPassword("123456");
        Connection connection = connectionFactory.newConnection();

        //创建一个通道
        Channel channel = connection.createChannel();

        //创建一个队列
        String queueName = "testQueue";
        channel.queueDeclare( queueName, false, false, false, null );

        //推送一个基本消息
        channel.basicPublish( "", queueName,
                null, "Hello MQ".getBytes(StandardCharsets.UTF_8) );

    }

}
